#!/usr/bin/perl

use warnings;
use strict;

if(2!=@ARGV)
    {
    print "Use: infotrace.pl file.info file.trace\n";
    exit(1);
    }

my $INFO=$ARGV[0];
my $TRACE=$ARGV[1];

my %FILE_LIST=();

open(IN, '<', $INFO) or die "Can't read '$INFO'!\n";
my $dir='';
while(<IN>)
    {
    if(/^Directory listing of\s*(.*)$/)
        { $dir=$1; }
    elsif(/^d/)
        { next; }
    elsif(/^\S+\s+\d+\s+\d+\s+\d+\s+(\d+)\s+[^\[]+\[\s*(\d+)\s+\d+\]\s+(.*)$/)
        {
        my($size, $sect, $name)=($1, $2, $3);
        0==$sect and next;
        $name=~s/\s*$//;
        $FILE_LIST{$sect}={NAME=>$dir.$name, OFFSET=>$sect*2048, END=>$sect*2048+$size};
        }
    }
close(IN);

my @FILE_ORDER=();

open(IN, '<', $TRACE) or die "Can't read '$TRACE'!\n";
my($name, $fd)=('', '');
my $last_file=undef;
my %seen=();
while(<IN>)
    {
    if(/^open\("([^"]+\.iso)"[^)]*\)\s*=\s*(\d+)/i)
        { ($name, $fd)=($1, $2); }
    elsif(/^_llseek\($fd,\s*\d+,\s*\[(\d+)\],\s* SEEK_SET\)/)
        {
        my $offset=$1;
        my $sect=$offset/2048;
#        if(defined($last_file) && $offset>=$last_file->{OFFSET} && $offset<$last_file->{END})
#            { next; }
        if(defined($FILE_LIST{$sect}))
            {
            $last_file=$FILE_LIST{$sect};
            if(!$seen{$last_file->{NAME}})
                {
                $seen{$last_file->{NAME}}=1;
                push(@FILE_ORDER, $last_file->{NAME});
                }
            }
        }
    }
close(IN);

my $weight=@FILE_ORDER;
foreach(@FILE_ORDER)
    {
    print "$_ $weight\n";
    --$weight;
    }
